VERSION 5.00
Begin VB.Form frmSysMenu 
   Caption         =   "Modify system and form menus"
   ClientHeight    =   2715
   ClientLeft      =   3405
   ClientTop       =   2805
   ClientWidth     =   4440
   Icon            =   "SysMenu.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   2715
   ScaleWidth      =   4440
   StartUpPosition =   2  'CenterScreen
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuFileSubMenu1 
         Caption         =   "&Sub menu 1001"
      End
   End
End
Attribute VB_Name = "frmSysMenu"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' SysMenu.frm
'
' By Herman Liu
'
' This demo application shows you how to use the API to modify the system menu, and message
' hooking to capture click events for inserted/appended items on the system menu.
'
' If you wish to test MenusInOtherApp(), (1) See remarks in the said procedure
' and (2) Add a command button and call the said procedure from its Click event.
'
Option Explicit



Private Sub Form_Activate()
    Dim mSysMenu As Long
    Dim mFormMenu As Long
    Dim mSubMenu As Long
    Dim mSubMenuList As Long
    Dim mSubSubMenuList As Long

    mSysMenu = GetSystemMenu(hWnd, False)
      ' Refer its position or constant.  For exmample, to delete a menu, Restore, Move, Size, Minimize,
      ' Maximize, Separator and Close (Pos of Restore being 0 and we delete it).
    DeleteMenu mSysMenu, 0, MF_BYPOSITION
    
    InsertMenu mSysMenu, 0, MF_BYPOSITION, MF_STRING + MF_ENABLED, "Inserted item"
    InsertMenu mSysMenu, 1, MF_BYPOSITION, MF_SEPARATOR, vbNullString
    
    AppendMenu mSysMenu, MF_SEPARATOR, 0, ""
    AppendMenu mSysMenu, MF_STRING + MF_ENABLED, 999, "Appended item"
    
      ' Now we want to separately add an item to form menu
    mFormMenu = GetMenu(Me.hWnd)
      ' MF_POPUP flag which is used for a new popup is also
      ' used for a new submenu
    mSubMenuList = CreatePopupMenu()
       
      ' We are to change form menu items
    mSubMenu = GetSubMenu(mFormMenu, 0)
    
      ' Add a separator to the form menu.
    InsertMenu mSubMenu, 1, MF_BYPOSITION, MF_SEPARATOR, vbNullString
   
      ' Add a new item to the form menu.  We allot an ID (any number
      ' that the application would not likely to have an identical one)
    AppendMenu mSubMenu, MF_STRING + MF_ENABLED, 1002, "Sub menu 1002"
    
      '---------------------------------------------------------------------
      ' We want to add a couple of "sub-submenu" items to the first submenu,
      ' therefore:
    mSubSubMenuList = CreatePopupMenu()
      ' We use "Sub menu 1001" which is the same as the original one, because
      ' we don't want to change it
    ModifyMenu mSubMenu, 0, MF_BYPOSITION + MF_POPUP, mSubSubMenuList, "Sub menu 1001"
    InsertMenu mSubSubMenuList, 0, MF_BYPOSITION, 2001, "Sub submenu 2001"
    InsertMenu mSubSubMenuList, 1, MF_BYPOSITION, 2002, "Sub submenu 2002"
      '------------------------------------------------------------
    
      ' Finally replace the orig Window Procedure
    OldWinProc = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf NewWindowProc)
End Sub


    
Private Sub MenusInOtherApp()
 ' NB: To call this procedure for testing, invoke your NotePad program and
 ' open a new document("Untitled - Notepad" being displayed) there first.
    Dim mHandle As Long
    Dim mAppMenu As Long
    Dim mAppSubMenu As Long
    Dim mAppSubMenuList As Long
    
    mHandle = FindWindow(vbNullString, "Untitled - Notepad")
    If mHandle = 0 Then
        MsgBox "You've not followed instruction yet"
        Exit Sub
    Else
        mAppMenu = GetMenu(mHandle)
        If mAppMenu = 0 Then
             MsgBox "Failed to access Notepad menu"
             Exit Sub
        End If
    End If
       ' Similar to that of Form_Activate()
    mAppSubMenuList = CreatePopupMenu()
    ModifyMenu mAppMenu, 0, MF_BYPOSITION + MF_POPUP, mAppSubMenuList, "Added Menu"
    mAppSubMenu = GetSubMenu(mAppMenu, 0)
    AppendMenu mAppSubMenu, MF_STRING + MF_ENABLED, 5001, "Added submenu 5001"
    MsgBox "Menus are added to NotePad"
End Sub



Private Sub Form_QueryUnload(Cancel As Integer, UnloadMode As Integer)
    RemoveOldProc Me.hWnd
End Sub

    
    


